﻿using Microsoft.AspNetCore.Components;
using Microsoft.Extensions.Configuration.UserSecrets;
using WF_WebAdmin.Model;
using WF_WebAdmin.Service;

namespace WF_WebAdmin.Pages
{
    public partial class DeleteUser
    {
        private bool showDeletePopup = false;
        private bool showModifyPopup = false;
        private User userToDelete = null;
        private User selectedUser;
        
        [Inject]
        public HttpClient Http { get; set; }

        [Inject]
        public NavigationManager NavigationManager { get; set; }
        
        private List<User> users;
        private UserServiceStub userService;

        protected override async Task OnInitializedAsync()
        {
            userService = new UserServiceStub($"fake-dataUser.json");
            users = await userService.GetUsersJson();
        }

        private void ShowDeleteConfirmation(User user)
        {
            // Afficher la modale et mémoriser l'utilisateur à supprimer
            userToDelete = user;
            showDeletePopup = true;
        }

        private void ShowModifyConfirmation(User user)
        {
            // Afficher la modale et mémoriser l'utilisateur à supprimer
            selectedUser = user;
            showModifyPopup = true;
        }

        private async Task RemoveUser()
        {
            if (userToDelete != null)
            {
                userService = new UserServiceStub($"fake-dataUser.json");
                await userService.DeleteUserJson(userToDelete.Id);
                ClosePopup();
            }
        }

        private async Task ModifyUser()
        {
            userService = new UserServiceStub($"fake-dataUser.json");
            await userService.UpdateUserJson(selectedUser);
            ClosePopup();
        }

        private void ClosePopup()
        {
            showDeletePopup = false;
            showModifyPopup = false;
        }
    }

}
