using Microsoft.AspNetCore.Components;
using Microsoft.AspNetCore.Mvc.RazorPages;
using WF_WebAdmin.Model;
using WF_WebAdmin.Service;

namespace WF_WebAdmin.Pages
{
    public partial class ModifQuote
    {
        private Quote[] quotes;

        private int MaxValue = 5;

        private int pages = 1;

        private int maxPage;

        private RenderFragment pagination;

        [Inject]
        public IQuoteService QuoteService { get; set; }

        protected override async Task OnInitializedAsync()
        {
            maxPage = await QuoteService.getNbQuote() / MaxValue;
            if(maxPage * MaxValue != await QuoteService.getNbQuote())
                maxPage += 1;
            List<Quote> quotesList = await QuoteService.getSomeQuote(MaxValue, pages);
            quotes = quotesList.ToArray();
            buildPagination();
        }

        protected void buildPagination()
        {
            if (pages == 1)
            {
                pagination = __builder =>
                {
                    __builder.AddMarkupContent(0, @"<button>1</button>
                        <button onClick='pageNumero(pages+1)'>@pages+1</button>
                        <button onClick='pageNumero(pages+2)'>@pages+2</button>
                        <p>...</p>
                        <button onClick='pageNumero(maxPage)'>@maxPage</button>
                        <button onClick='pageSuivante()'>></button>");
                };
            }

        }

        protected async Task pageSuivante()
        {
            pages += 1;
            List<Quote> quotesList = await QuoteService.getSomeQuote(MaxValue, pages);
            quotes = quotesList.ToArray();
        }

        protected async Task pagePrcdente()
        {
            if (pages > 1)
            {
                pages -= 1;
                List<Quote> quotesList = await QuoteService.getSomeQuote(MaxValue, pages);
                quotes = quotesList.ToArray();
            }
        }

        protected async Task pageNumero(int page)
        {
            this.pages = page;
            List<Quote> quotesList = await QuoteService.getSomeQuote(MaxValue, this.pages);
            quotes = quotesList.ToArray();
        }
    }
}
